#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2  Lime
#property indicator_width1 2
#property indicator_width2 2
#define SignalName "Leledc-FI"

#define  BUY   1
#define  SELL -1


extern int ForcePeriod=13;
extern int Ma=21;
extern int ForceMAMode=2;
extern int ForceAppliedPrice=3;
extern bool AlertOn=false;
extern bool Draw_Arrow=true;
extern int WidthArrow=2;
extern color colorup=DodgerBlue;
extern color colordown=Red;
extern bool Five_Digits_Broker=true;
int i,count;
bool TurnedUp = false;
bool TurnedDown = false;
double distanceup=0;
  double distancedown=0;
//---- buffers
double ExtForceBuffer[];
double MaBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   DeleteObjects();
   string ShortName;
   SetIndexBuffer(0,ExtForceBuffer);
   SetIndexStyle(0,DRAW_LINE);
    SetIndexBuffer(1,MaBuffer);
   SetIndexStyle(1,DRAW_LINE);
   return(0);
  }
  int deinit() {
   
     DeleteObjects();
}
//+------------------------------------------------------------------+
//| Force Index indicator                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  if (Five_Digits_Broker==true){
  distanceup=50*Point;
  distancedown=150*Point;
  }
  else{
  distanceup=5*Point;
  distancedown=15*Point;
  
  }
  
   int limit,LastSignal,limit2;
  int counted_bars = IndicatorCounted();
if(counted_bars > 0) 
counted_bars--;
limit = Bars - counted_bars; 
if (limit2 < Bars ) 
limit = Bars;


   for(int i=limit; i>=0; i--)
   {
   ExtForceBuffer[i]=Volume[i]*(iMA(NULL,0,ForcePeriod,0,ForceMAMode,ForceAppliedPrice,i)-iMA(NULL,0,ForcePeriod,0,ForceMAMode,ForceAppliedPrice,i+1));
 
}   
    for(i=limit; i>=0; i--){
       MaBuffer[i]=iMAOnArray(ExtForceBuffer,0,Ma,0,ForceMAMode,i);
}

for(i=limit; i>=0; i--){
 if (i!=0){
         if ( ExtForceBuffer [i]> MaBuffer[i] && LastSignal!=BUY){
           LastSignal=BUY;
         
         if (Draw_Arrow  ){
         DrawArrow(i,"Up" );
         }
         if  (AlertOn && i==1 && !TurnedUp )
           { 
            Alert("Leledc FI is going UP on"+" "+Symbol()," ",Period()+" "+"minute charts");
             
             TurnedUp = true;
            TurnedDown = false;
     }
       }
        }
        if (i!=0){
    if  (ExtForceBuffer [i]<MaBuffer[i] && LastSignal!=SELL ){
         LastSignal=SELL;
        
           if (Draw_Arrow ){
            DrawArrow(i,"Down");
            }
            if  (AlertOn  && i==1 && !TurnedDown )
           { 
           Alert("Leledc FI is going DOWN on"+" "+Symbol()," ",Period()+" "+"minute charts");
            TurnedUp = false;
            TurnedDown = true;
     }
  }
}
}
if (i> limit2) 
   limit2= i;
return(0);
  }
///////////////////////////////////////////////
//            DrawArrowFunction             //
/////////////////////////////////////////////
void DrawArrow(int i,string type)
{     count++;
      string name2 = StringConcatenate(SignalName,count);
     ObjectCreate(name2,OBJ_ARROW,0,Time[i],0);
      if (type=="Up")
         {
            ObjectSet(name2,OBJPROP_PRICE1,Low[i]-(distanceup));
            ObjectSet(name2,OBJPROP_ARROWCODE,233);
            ObjectSet(name2,OBJPROP_COLOR,colorup);
            ObjectSet(name2,OBJPROP_WIDTH,WidthArrow);
         }
      else if (type=="Down")
         {
            ObjectSet(name2,OBJPROP_PRICE1,High[i]+(distancedown));
            ObjectSet(name2,OBJPROP_ARROWCODE,234);
             ObjectSet(name2,OBJPROP_WIDTH,WidthArrow);
            ObjectSet(name2,OBJPROP_COLOR,colordown);
        }
        }
///////////////////////////////////////////////
//             DeleteFunction               //
/////////////////////////////////////////////

void DeleteObjects(){

 for (count = 0; count < ObjectsTotal(); count++) {
      if ((StringFind(ObjectName(count), SignalName) == 0)) {
         ObjectDelete(ObjectName(count));
         count--;
         }
         }
         }